<!--
	Markdown
	
	Copyright 2017 IS2T. All rights reserved.
	Modification and distribution is permitted under certain conditions.
	IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
-->
# Overview
The SSL implementation for GRPEACH platform relies on mbedtls TLS stack version 2.4.0.

# Source
Mbedtls implementation sources used are from revision : mbed TLS 2.4.0 branch released 2016-10-17


#MbedTLS configuration file
In e2studio project, MBEDTLS_CONFIG_FILE id defined to "microej\ssl\inc\LLNET_SSL_mbedtls_config.h" in order to use custom mbedtls configuration file

-Activated options :
--MBEDTLS_PLATFORM_MEMORY
--MBEDTLS_PLATFORM_NO_STD_FUNCTIONS
--MBEDTLS_TIMING_ALT
--MBEDTLS_NO_PLATFORM_ENTROPY
--MBEDTLS_HAVEGE_C

-Disabled options :
--MBEDTLS_FS_IO
--MBEDTLS_NET_C

-Defines added:
--MBEDTLS_PLATFORM_CALLOC_MACRO and MBEDTLS_PLATFORM_FREE_MACRO
--MBEDTLS_PLATFORM_TIME_MACRO
--MBEDTLS_PLATFORM_FPRINTF_MACRO and MBEDTLS_PLATFORM_PRINTF_MACRO

#Entropy limitation and configuration
No hardware random number generator is available on GRPEACH, to have minimum entropy, the MBEDTLS_TIMING_ALT functions is used to have time entropy and MBEDTLS_HAVEGE_C have been activated.

#modifications
The modified files in the Third_Party folder that have been modified :
- check_config.h : add condition when TARGET_LIKE_MBED is defined and TIMING modules are not available for mbed OS but TIMING_ALT are defined.
- platform.c : Add preprocessor conditions to remove multiple definition of mbedtls_calloc and mbedtls_free in case of MBEDTLS_PLATFORM_STD_{CALLOC|FREE} are defined.
- x509_crt.c : Add preprocessor condition to remove include of "dirent.h" if MBEDTLS_FS_IO is not defined. Remove the check of null character at the end of the certificate buffer.
- x509.c : Add preprocessor condition to remove include of "dirent.h" if MBEDTLS_FS_IO is not defined.


