/*
 * Copyright 2017 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

#ifndef _DEVICE_UID_H
#define _DEVICE_UID_H

/* Defines -------------------------------------------------------------------*/

/* Define flash area where is stored the 18 bytes UID assigned to the board followed by 16 bit checksum (compute by sum of the bytes) */
#define GRPEACH_FLASH_ADDR_START                0x18000000
#define GRPEACH_FLASH_UID_BLOC_OFFSET           0x7FF000
#define GRPEACH_FLASH_UID_ADDR_OFFSET           0x7FFFEC
#define GRPEACH_FLASH_UID_ADDR_START            GRPEACH_FLASH_ADDR_START+GRPEACH_FLASH_UID_ADDR_OFFSET

#define GRPEACH_FLASH_UID_ADDR_SIZE             18
#define GRPEACH_FLASH_UID_CHECKSUM_SIZE         2
#define GRPEACH_FLASH_UID_ADDR_CHECKSUM_MSB     ((GRPEACH_FLASH_UID_ADDR_SIZE+GRPEACH_FLASH_UID_CHECKSUM_SIZE)-2)
#define GRPEACH_FLASH_UID_ADDR_CHECKSUM_LSB     ((GRPEACH_FLASH_UID_ADDR_SIZE+GRPEACH_FLASH_UID_CHECKSUM_SIZE)-1)

/* API -----------------------------------------------------------------------*/

void init_device_uid(void);

#endif
