/*
 * Copyright 2016 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/* Includes ------------------------------------------------------------------*/

#include "LLBSP_impl.h"
#include "microej.h"
#include <stdio.h>

/* Defines -------------------------------------------------------------------*/

/**
 * Memory settings
 */
#define MEM_L_TTB_START	        (0x20000000)
#define MEM_L_TTB_END	        (MEM_L_TTB_START + 0x00004000)
#define MEM_RAM_START           (0x20020000)
#define MEM_RAM_END             (MEM_RAM_START + 0x00700000)
#define MEM_RAM_NC_START        (0x20900000)
#define MEM_RAM_NC_END	        (MEM_RAM_NC_START + 0x00100000)

/* Public functions ----------------------------------------------------------*/

// Checks if the given pointer is in a read only memory or not.
uint8_t LLBSP_IMPL_isInReadOnlyMemory(void* ptr)
{
	if(
		((uint32_t)ptr >= MEM_L_TTB_START && (uint32_t)ptr < MEM_L_TTB_END) ||
		((uint32_t)ptr >= MEM_RAM_START && (uint32_t)ptr < MEM_RAM_END) ||
		((uint32_t)ptr >= MEM_RAM_NC_START && (uint32_t)ptr < MEM_RAM_NC_END)
	)
		return MICROEJ_FALSE;
	else
		return MICROEJ_TRUE;
}

/**
 * Writes the character <code>c</code>, cast to an unsigned char, to stdout stream.
 * This function is used by the default implementation of the Java <code>System.out</code>.
 */
void LLBSP_IMPL_putchar(int32_t c)
{
	putchar(c);
}
