/*
 * C
 *
 * Copyright 2017 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

#include <stdint.h>

extern uint32_t __start_ram_progFlash__;
extern uint32_t __end_ram_progFlash__;
extern uint32_t __start_flash_progFlash__;

#if defined (__CC_ARM)
#pragma arm section code = "HANDLER"
#endif

void copyTextInRam()
{
	uint32_t i,loop_num;

	uint32_t *ram_start,*ram_end;

	uint32_t region_size;

	uint32_t *src_start;

	/* Initialisation of text section in RAM */
	/* Global variables are specified in the load file (.ld) */
	ram_start = &__start_ram_progFlash__;
	ram_end = &__end_ram_progFlash__;

	/* Calculate the length of the copied section */
    region_size     = (uint32_t)(ram_end - ram_start);

	loop_num = region_size;


	/* Point text in ROM */
	src_start = (uint32_t *)&__start_flash_progFlash__;


    /* Copy the data. */
    for(i = 0; i < loop_num; i++)
    {
        *ram_start++ = *src_start++;
    }

}
