/*
 * C
 *
 * Copyright 2017 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
#include "r_spibsc_ioset_api.h"
#include "r_spibsc_flash_api.h"
#include "spibsc.h"
#include "spibsc_config.h"
#include "device_uid.h"

///* External function prototypes ----------------------------------------------*/
//
//extern void PekoeSpibsc_init1(void);
//extern uint8_t PekoeSpibsc_init2(uint32_t dual);
//
//
///* Private Functions  --------------------------------------------------------*/
//
//static void pre_qspi(void)
//{
//	PekoeSpibsc_init1();
//	PekoeSpibsc_init2(SPIBSC_CMNCR_BSZ_SINGLE);
//}
//
//static void post_qspi(void)
//{
//	PekoeSpibsc_init2(SPIBSC_CMNCR_BSZ_SINGLE);
//}

/* Functions  ---------------------------------------------------------------*/

int32_t write_uid_to_flash(uint8_t* UIDFlash_buffer)
{
	int32_t ret = 0;
	//Disconnect Flash memory mapping
	ret = R_SFLASH_Spimode(0);

	//Erase last sector
	if (ret == 0){
		ret = R_SFLASH_EraseSector(GRPEACH_FLASH_UID_BLOC_OFFSET, 0, SPIBSC_CMNCR_BSZ_SINGLE, SPIBSC_1BIT, SPIBSC_OUTPUT_ADDR);
	}

	//Write buffer to Flash
	if (ret == 0){
		ret = R_SFLASH_ByteProgram(GRPEACH_FLASH_UID_ADDR_OFFSET,
								   UIDFlash_buffer,
								   GRPEACH_FLASH_UID_ADDR_SIZE+GRPEACH_FLASH_UID_CHECKSUM_SIZE,
								   0,
								   SPIBSC_CMNCR_BSZ_SINGLE,
								   SPIBSC_1BIT,
								   SPIBSC_OUTPUT_ADDR);
	}

	// Switch back memory mapped
	R_SFLASH_Exmode(0);

	return ret;
}
