/*
 * * C
 *
 * Copyright 2017 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

#ifndef MICROEJ_HAL_HAL_MBED_H_
#define MICROEJ_HAL_HAL_MBED_H_

/* Includes ------------------------------------------------------------------*/

#include <stdint.h>
#include <stdio.h>
#include "LLHal_GPIO_impl.h"
#include "mbed.h"
#include "pinmap.h"



/* Defines -------------------------------------------------------------------*/

#define NUMBER_OF_ANALOG_PINS 6
#define NUMBER_OF_PWM_CHANNELS 8

/*
 * Global virtual MCU port
 */
#define HAL_GPIO_PORT_MCU 0

/* Structs -------------------------------------------------------------------*/
typedef struct {
	PinName      pinName;
	analogin_t   analog;
}analogPin_t;

typedef struct {
	PinName pinName;
	pwmout_t _pwm;
}pwmoutPin_t;

/* API -----------------------------------------------------------------------*/

/*
 * Fill the structure for the given port and pin
 */

int32_t hal_get_gpio_data(int32_t port, int32_t pin, gpio_t* gpio);

/* EOF -----------------------------------------------------------------------*/


#endif /* MICROEJ_HAL_HAL_MBED_H_ */
