/*
 * C
 *
 * Copyright 2015-2017 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
#ifndef LLNET_SOCKETCHANNEL_LWIP_H
#define LLNET_SOCKETCHANNEL_LWIP_H

#ifdef __cplusplus
	extern "C" {
#endif

#include "lwipopts.h"

//Import symbols from linker
extern uint32_t __SOCKET_TIMEOUT_MEM_Start__;
extern uint32_t __SOCKET_TIMEOUT_MEM_End__;

#define SOCKET_TIMEOUT_MEM_SIZE    ( ((uint32_t)&__SOCKET_TIMEOUT_MEM_End__) - ((uint32_t)&__SOCKET_TIMEOUT_MEM_Start__) )

/* types --------------------------------------------------------------------------*/

/*
 * threadFdTimeout_t structure to store the timeout for every fd for a specific thread
 * WARNING : If modified, (or MEMP_NUM_TCP_PCB changed) the static memory allocation in RZA1H.ld file should be modified
 * */
typedef struct {
	int32_t threadId;
	int64_t timeoutTable[MEMP_NUM_TCP_PCB];
}threadFdTimeout_t;

/*  API ------------------------------------------------------------------ */

int32_t SocketChanel_Address(int32_t fd, int8_t* name, uint8_t localAddress);

int32_t SocketChanel_Port(int32_t fd, uint8_t localPort);

#ifdef __cplusplus
	}
#endif

#endif	// LLNET_SOCKETCHANNEL_LWIP_H
