/*
 * C
 *
 * Copyright 2013-2016 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/* Includes ------------------------------------------------------------------*/

#include "BESTFIT_ALLOCATOR.h"
#include <sni.h>
#include <stdio.h>
#include <string.h>
#include "bsp_util.h"

#ifdef __cplusplus
	extern "C" {
#endif

//Declare SSL memory buffer
BSP_DECLARE_BUFFER(SSL_MEM)
//SSL memory allocator
BESTFIT_ALLOCATOR SSL_allocatorInstance;

//#define ALLOCATOR_DEBUG

/* API -----------------------------------------------------------------------*/

void LLNET_SSL_MEM_initialize(){
	BESTFIT_ALLOCATOR_new(&SSL_allocatorInstance);
	BESTFIT_ALLOCATOR_initialize(&SSL_allocatorInstance, SSL_MEM_START, SSL_MEM_END);
#ifdef ALLOCATOR_DEBUG
	printf("LLNET_SSL_MEM_init %p - %p \n", SSL_MEM_START, SSL_MEM_END);
#endif
}

void* LLNET_SSL_MEM_allocate(int32_t size){
    void* allocationStart = BESTFIT_ALLOCATOR_allocate(&SSL_allocatorInstance, size);
#ifdef ALLOCATOR_DEBUG
	printf("LLNET_SSL_MEM_allocate %d %p \n", size, allocationStart);
#endif
    return (void*)allocationStart;
}


void LLNET_SSL_MEM_free(void* block){
	if(block){
		BESTFIT_ALLOCATOR_free(&SSL_allocatorInstance, block);
	}
#ifdef ALLOCATOR_DEBUG
    printf("LLNET_SSL_MEM_free %p -\n", block);
#endif
}

#ifdef __cplusplus
	}
#endif
