/*
 * C
 *
 * Copyright 2015-2017 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
#include <LLNET_SSL_X509_CERT_impl.h>
#include <LLNET_SSL_CONSTANTS.h>
#include <LLNET_SSL_ERRORS.h>
#include <LLNET_SSL_utils_mbedtls.h>
#include <stdlib.h>
#include <sni.h>

#include "mbedtls/ssl.h"


#ifdef __cplusplus
	extern "C" {
#endif

int32_t LLNET_SSL_X509_CERT_IMPL_parse(int8_t *cert, int32_t off, int32_t len, uint8_t retry){
	LLNET_SSL_DEBUG_TRACE("%s(cert=%p, off=%d, len=%d)\n", __func__, cert, off, len);

	int32_t format = J_CERT_PARSE_ERROR;

	/* Parse certificate to check if there is any error. Embed TLS doesn't store the format of the certificate
	 * return CERT_PEM_FORMAT by default
     */
	mbedtls_x509_crt _cacert;
	mbedtls_x509_crt_init(&_cacert);

	int ret;
    if ((ret = mbedtls_x509_crt_parse(&_cacert, (const unsigned char *) (cert+off), len)) != 0) {
    	LLNET_SSL_DEBUG_MBEDTLS_TRACE("mbedtls_x509_crt_parse", ret);
    }
    else
    {
    	format = CERT_PEM_FORMAT;
    }

	return format;
}

#ifdef __cplusplus
	}
#endif
