@ECHO OFF 
REM Copyright 2016-2017 IS2T. All rights reserved.
REM For demonstration purpose only.
REM IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.

set jlinkFile=writeUID.jlink

set UIDLoc=(0x187FFFEC 0x187FFFED 0x187FFFEE 0x187FFFEF 0x187FFFF0 0x187FFFF1 0x187FFFF2 0x187FFFF3 0x187FFFF4 0x187FFFF5 0x187FFFF6 0x187FFFF7 0x187FFFF8 0x187FFFF9 0x187FFFFA 0x187FFFFB 0x187FFFFC 0x187FFFFD 0x187FFFFE 0x187FFFFF)
set UIDSize=20

REM UID address Value : 18 first bytes for UID address, last 2 bytes is additive checksum (leave 0 for script computation)
set UIDList=(55 33 88 56 93 ea 19 40 aa c1 60 f8 c9 f6 9f dd b1 cb 00 00)

setlocal ENABLEDELAYEDEXPANSION


REM convert UIDList list to array
set n=0
set checksum=0
for %%a in %UIDList% do (
	set UIDArray[!n!]=%%a
	set /A n+=1
	set /A checksum+=0x%%a
)

REM convert UIDLoc list to array
set n=0
for %%a in %UIDLoc% do (
	set UIDLocArray[!n!]=%%a
	set /A n+=1
)

REM compute checksum
if %UIDArray[18]% == 00 (
	if %UIDArray[19]% == 00 (
		
		set "map=0123456789ABCDEF"

		set "hex="
		set /A checksumMSB=!checksum!/256
		for /L %%N in (1,1,2) do (
			set /a "d=checksumMSB&15,checksumMSB>>=4"
			for %%D in (!d!) do set "hex=!map:~%%D,1!!hex!"
		)
		set UIDArray[18]=!hex!
		
		set "hex="
		set /A checksumLSB=!checksum!-checksumLSB*256
		for /L %%N in (1,1,2) do (
			set /a "d=checksumLSB&15,checksumLSB>>=4"
			for %%D in (!d!) do set "hex=!map:~%%D,1!!hex!"
		)
		set UIDArray[19]=!hex!
	)
)

REM write fisrt command in file then append
echo si 1 > %jlinkFile%
echo speed 4000 >> %jlinkFile%

REM Reset and Halt board
echo r >> %jlinkFile%
echo h >> %jlinkFile%

echo mem !UIDLocArray[0]! %UIDSize% >> %jlinkFile%

set /A lastIndex=!UIDSize!-1
for /L %%i in (0, 1, !lastIndex!) do (
	echo w1 !UIDLocArray[%%i]! !UIDArray[%%i]!
	set /A n+=1
) >> %jlinkFile%
  

echo mem !UIDLocArray[0]! %UIDSize% >> %jlinkFile%

echo exit >> %jlinkFile%

endlocal

"C:\Program Files (x86)\SEGGER\JLink_V512e\JLink.exe" -device R7S721001 -CommanderScript writeUID.jlink